int inputPin = A0;  // set input pin for the potentiometer
int inputValue = 0; // potentiometer input variable
int SSRPin = D7;     // set output pin for the LED
int SSRPin2 = D8;
int analogF = 26;
#include <ESP8266WiFi.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,20,4); 
const int buttonPin = 14;
int buttonState = 0;
int set_pwm = 1;
int ai = 0;
int ssr;
int LCDssr;
int ssrDis;

void setup() {

  WiFi.mode(WIFI_STA);
   Serial.begin(115200);
     // declare the SSRPin as an OUTPUT:
     pinMode(SSRPin, OUTPUT);
     pinMode(SSRPin2, OUTPUT);
     analogWriteFreq(analogF);
     pinMode(buttonPin, INPUT);
       lcd.init();                      // initialize the lcd 
 // lcd.init();
  // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("SSR  Slow Start");
  lcd.setCursor(2,1);
  lcd.print("Controller!");
}

void loop() {
  buttonState = digitalRead(buttonPin);
     // read the value from the potentiometer:
inputValue = analogRead(inputPin);  
if (inputValue > 742){ LCDssr =2 ;ssrDis =map(inputValue,742,1023,0,1023);ssrDis =(( 1023 - ssrDis)/10);}else{ LCDssr=1; ssrDis= ((map(inputValue,0,741,0,1023))/10.3);}
// the weird mapping is so that  the analog dial sat in the middle 

  if (buttonState == HIGH) {
    // turn SSR on
      if (set_pwm == 0){
                 inputValue = analogRead(inputPin);
                 Serial.print("____");Serial.println(inputValue);

       
       if (inputValue > 740){ ssr = 0;}else{ssr= map(inputValue,0,741,0,1023);}
       
       ai = ssr/10;
       for(int i=0;i <ai; i++){
         buttonState = digitalRead(buttonPin);
        if (buttonState == LOW) { Serial.println("BREAK"); set_pwm = 1; break;}
      
        analogWrite(SSRPin,(i*10));
        Serial.print("SSR-1 "); Serial.print(i*10); Serial.print(" ");Serial.println(ai);
        delay(200);
        buttonState = digitalRead(buttonPin);
        if (buttonState == LOW) { Serial.println("BREAK"); set_pwm = 1; break;}
      
       }
       Serial.println(inputValue);
       if (inputValue > 750){ ssr =map(inputValue,750,1023,0,1023);ssr = 1023 - ssr;}else{ssr = 0;}
       Serial.println(ssr);
      
        ai = ssr/10;
              for(int i=0;i <ai; i++){
          buttonState = digitalRead(buttonPin);
        if (buttonState == LOW) { Serial.println("BREAK"); set_pwm = 1; break;}
            
        analogWrite(SSRPin2,(i*10));
        Serial.print("SSR-2 "); Serial.print(i*10); Serial.print(" ");Serial.println(1023-(inputValue -1023));
        delay(200);
       }
      set_pwm = 1; 
    }
      
  } else {
    // turn SSR off
     if(set_pwm == 1){
        analogWrite(SSRPin, 0);
        analogWrite(SSRPin2, 0);
        set_pwm = 0;
        Serial.println("pulse is off");
   }
  }
  delay(200);
    lcd.clear();
lcd.setCursor(0,0);  
lcd.print("SSR "); lcd.print(LCDssr);lcd.print("  ");lcd.print(ssrDis);lcd.print(" % ");

}
